//---------------------------------------------------------------------------

#ifndef UnitMainH
#define UnitMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <Graphics.hpp>
#include <Menus.hpp>
#include <Buttons.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TFormMain : public TForm
{
__published:	// IDE-managed Components
	TImageList *ImageListSegments;
	TMainMenu *MainMenu1;
	TMenuItem *MReset;
	TGroupBox *GroupBoxDisplay;
	TImage *ImageDisplay;
	TGroupBox *GroupBoxKeypad;
	TGroupBox *GroupBoxDebug;
	TImage *ImageDebug;
	TImage *ImageKeypad;
	TGroupBox *GroupBoxControl;
	TSpeedButton *SpeedButtonReset;
	TSpeedButton *SpeedButtonRun;
	TSpeedButton *SpeedButtonPause;
	TSpeedButton *SpeedButtonAdvance;
	TSpeedButton *SpeedButtonTurbo;
	TMenuItem *MDiodes;
	TMenuItem *MNoDiodes;
	TMenuItem *N1;
	TMenuItem *MDiodesVD1;
	TMenuItem *MDiodesVD2;
	TMenuItem *MDiodesVD3;
	TMenuItem *MDiodesVD4;
	TMenuItem *MView;
	TMenuItem *MViewKeypad;
	TMenuItem *MViewDebug;
	TOpenDialog *OpenDialogROM;
	TMenuItem *MSystem;
	TMenuItem *N2;
	TMenuItem *MLoadROM;
	TLabel *LabelLED1;
	TShape *ShapeLED1;
	TShape *ShapeLED2;
	TLabel *LabelLED2;
	TTimer *Timer1;
	TSpeedButton *SpeedButtonHandsetDown;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormMouseLeave(TObject *Sender);
	void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift, int X,
		  int Y);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall MResetClick(TObject *Sender);
	void __fastcall ImageKeypadMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall ImageKeypadMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall ImageKeypadMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall FormPaint(TObject *Sender);
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall FormKeyUp(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall SpeedButtonResetClick(TObject *Sender);
	void __fastcall SpeedButtonAdvanceClick(TObject *Sender);
	void __fastcall MNoDiodesClick(TObject *Sender);
	void __fastcall FormDeactivate(TObject *Sender);
	void __fastcall MViewKeypadClick(TObject *Sender);
	void __fastcall MLoadROMClick(TObject *Sender);
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall SpeedButtonHandsetDownClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
	__fastcall TFormMain(TComponent* Owner);
	void __fastcall DrawKey(TCanvas *c,int x,int y,AnsiString label,bool state);
	void __fastcall DrawKeyboard(void);
	void __fastcall CheckKeyboard(int x,int y,bool down);
	void __fastcall ReleaseKeys(void);
	void __fastcall DrawDisplay(TCanvas *c,int x,int y);
	void __fastcall DrawDebugInfo(TImage *img);
	void __fastcall DrawLEDs(TCanvas *c,int x,int y);
	void __fastcall UpdateWindowsView(void);
	void __fastcall ConfigLoad(void);
	void __fastcall ConfigSave(void);
	void __fastcall LoadROM(void);
	void __fastcall UpdateEmu(void);

	bool UpdateActive;
};
//---------------------------------------------------------------------------
extern PACKAGE TFormMain *FormMain;
//---------------------------------------------------------------------------
#endif
